import React from 'react';
import styled from 'styled-components';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var PanelContainerDiv = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  height: 100%;\n  width: 100%;\n  left: 0;\n  top: 0;\n  position: absolute;\n  overflow-y: auto;\n  &::-webkit-scrollbar {\n    display: none;\n  }\n  -ms-overflow-style: none;\n"], ["\n  height: 100%;\n  width: 100%;\n  left: 0;\n  top: 0;\n  position: absolute;\n  overflow-y: auto;\n  &::-webkit-scrollbar {\n    display: none;\n  }\n  -ms-overflow-style: none;\n"])));
var InnerScrollDiv = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  flex: 1;\n  overflow-y: auto;\n  flex-shrink: ", ";\n  @media (min-width: ", "px) {\n    flex-shrink: 1;\n  }\n"], ["\n  flex: 1;\n  overflow-y: auto;\n  flex-shrink: ", ";\n  @media (min-width: ", "px) {\n    flex-shrink: 1;\n  }\n"])), function (_a) {
    var panelY = _a.panelY;
    return (panelY === 1 ? 1 : 0);
}, function (_a) {
    var breakpoint = _a.breakpoint;
    return breakpoint;
});
var BackgroundDiv = styled.div.attrs(function (_a) {
    var panelY = _a.panelY;
    return ({
        style: {
            zIndex: panelY ? 2 : 0,
            background: "hsla(0,0%,0%, " + panelY / 4 + ")"
        }
    });
})(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  position: sticky;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  opacity: 1;\n  @media (min-width: ", "px) {\n    opacity: 0;\n    pointer-events: none;\n  }\n"], ["\n  position: sticky;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  opacity: 1;\n  @media (min-width: ", "px) {\n    opacity: 0;\n    pointer-events: none;\n  }\n"])), function (_a) {
    var breakpoint = _a.breakpoint;
    return breakpoint;
});
var PanelDiv = styled.div.attrs(function (_a) {
    var margin = _a.margin, panelY = _a.panelY;
    return ({
        style: {
            cursor: !panelY ? "pointer" : "auto",
            width: "calc(100% - " + (1 - panelY) * margin + "px)"
        }
    });
})(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  z-index: 2;\n  position: absolute;\n  margin: auto 0px;\n  display: flex;\n  flex-direction: column;\n  background: white;\n  overflow-y: hidden;\n  border-radius: 8px 8px 0px 0px;\n  left: 0;\n  max-width: 448px;\n  max-height: calc(100% - ", "px);\n  pointer-events: all;\n  left: 50%;\n  transform: translateX(-50%);\n  min-height: ", "px;\n  top: calc(100% - ", "px);\n  @media (min-width: ", "px) {\n    cursor: auto !important;\n    top: auto;\n    bottom: 0;\n    left: ", "px;\n    transform: translateX(0%);\n  }\n"], ["\n  z-index: 2;\n  position: absolute;\n  margin: auto 0px;\n  display: flex;\n  flex-direction: column;\n  background: white;\n  overflow-y: hidden;\n  border-radius: 8px 8px 0px 0px;\n  left: 0;\n  max-width: 448px;\n  max-height: calc(100% - ", "px);\n  pointer-events: all;\n  left: 50%;\n  transform: translateX(-50%);\n  min-height: ", "px;\n  top: calc(100% - ", "px);\n  @media (min-width: ", "px) {\n    cursor: auto !important;\n    top: auto;\n    bottom: 0;\n    left: ", "px;\n    transform: translateX(0%);\n  }\n"])), function (_a) {
    var margin = _a.margin;
    return margin;
}, function (_a) {
    var minHeight = _a.minHeight;
    return minHeight;
}, function (_a) {
    var minHeight = _a.minHeight;
    return minHeight;
}, function (_a) {
    var breakpoint = _a.breakpoint;
    return breakpoint;
}, function (_a) {
    var margin = _a.margin;
    return margin;
});
var Layout = React.memo(function (_a) {
    var children = _a.children, onScroll = _a.onScroll, isOpen = _a.isOpen, _b = _a.snapback, snapback = _b === void 0 ? 48 : _b, _c = _a.minHeight, minHeight = _c === void 0 ? 128 : _c, _d = _a.breakpoint, breakpoint = _d === void 0 ? 1024 : _d, _e = _a.margin, margin = _e === void 0 ? 16 : _e, _f = _a.panel, panel = _f === void 0 ? PanelDiv : _f, _g = _a.container, container = _g === void 0 ? PanelContainerDiv : _g, _h = _a.background, background = _h === void 0 ? BackgroundDiv : _h;
    var _j = React.useState({
        isOpen: false,
        panelY: 0
    }), state = _j[0], setState = _j[1];
    var containerRef = React.useRef(null);
    var panelRef = React.useRef(null);
    var setProps = function (props) {
        setState(__assign(__assign({}, state), props));
    };
    var closePanel = function () {
        if (panelRef.current) {
            panelRef.current.scrollTo({ top: 0, behavior: "smooth" });
        }
        if (containerRef.current) {
            containerRef.current.scrollTo({ top: 0, behavior: "smooth" });
        }
    };
    var openPanel = function () {
        if (containerRef.current && panelRef.current) {
            containerRef.current.scrollTo({
                top: containerRef.current.offsetHeight,
                behavior: "smooth"
            });
        }
    };
    React.useEffect(function () {
        if (isOpen !== undefined) {
            (isOpen ? openPanel : closePanel)();
        }
    }, [isOpen, containerRef.current]);
    var snapScroll = function () {
        if (containerRef.current &&
            ((state.isOpen && state.panelY < 1) ||
                (!state.isOpen && state.panelY > 0))) {
            var offset = state.isOpen
                ? containerRef.current.scrollTop
                : containerRef.current.scrollHeight - containerRef.current.scrollTop;
            return Math.abs(offset) > snapback ? openPanel() : closePanel();
        }
    };
    var onScrollPanel = function (e) {
        var panelY = e.currentTarget.scrollTop /
            (e.currentTarget.scrollHeight - e.currentTarget.offsetHeight);
        setProps({
            isOpen: panelY === 1 ? true : panelY === 0 ? false : state.isOpen,
            panelY: panelY
        });
        if (onScroll) {
            onScroll(panelY);
        }
    };
    var Panel = panel;
    var Container = container;
    var Background = background;
    return (React.createElement(Container, { ref: containerRef, onScroll: onScrollPanel, onTouchEnd: snapScroll },
        React.createElement(Background, { onClick: closePanel, panelY: state.panelY, breakpoint: breakpoint }),
        React.createElement(Panel, { ref: panelRef, minHeight: minHeight, margin: margin, breakpoint: breakpoint, onClick: !state.panelY ? openPanel : function () { return null; }, panelY: state.panelY }, children)));
});
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;

export default Layout;
export { BackgroundDiv, InnerScrollDiv, Layout, PanelContainerDiv, PanelDiv };
//# sourceMappingURL=index.es.js.map
